// Manual for created functions, the manula file is created with python
// using bypicman.py
//
constant manFile$ "help.txt"

// *****************************************************************************
// lists just the function names
// *****************************************************************************
function help.list()
dim f,k,p,s$[80]
dim sl, tpos=0
    f = fopen(manFile$, "r")
    if f <> 0 then
        k = fgets(s$,f)
        while k = 0
            sl = strlen(s$)
            if sl > 1 then
                p = pos(s$,"#")
                print mid$(s$,0,p)
                tpos=tpos+sl
                if tpos > 79 then
                    tpos=0
                    print "\n"
                endif
                while (tpos % 20) <> 0
                    print " "
                    tpos=tpos+1
                wend
                k = fgets(s$,f)        
            else
                k = 10
            endif
        wend
        fclose(f)
    else
        print "cant open ",manFile$    
    endif
endf

// *****************************************************************************
// gets id so that nay comment can be found
// *****************************************************************************
function getFnID$(fun$[40],f)
dim k,p,s$[80], rv$[10]
    if f <> 0 then
        k = fgets(s$,f)
        while k = 0
            if strlen(s$) > 1 then
                p = pos(s$,"#")
                if mid$(s$,0,p)=fun$ then                    
                    p = pos(s$,"#")
                    rv$ = mid$(s$,p,10)
                    k = 10
                endif
                k = fgets(s$,f)
            else
                k = 10        
            endif
        wend
    else
        print "cant open ",manFile$    
    endif
    return rv$
endf

// *****************************************************************************
// *****************************************************************************
function pComments(fun$[40],comment)
dim f,k,id$[10],s$[80],sl
    f = fopen(manFile$, "r")
    if f <> 0 then
        id$=getFnID$(fun$,f)
        //print id$
        k = fgets(s$,f)
        while k = 0
            sl = strlen(id$)-1
            if mid$(s$,0,sl)=mid$(id$,0,sl) then                    
                print mid$(s$,sl+1,200) // function name
                if comment = 1 then
                    while strlen(s$) > 1
                        k = fgets(s$,f)
                        print s$
                    wend
                endif                    
                k = 10
            endif
            if k = 0 then
                k = fgets(s$,f)
            endif
        wend                  
        fclose(f)  
    else
        print "cant open ",manFile$    
    endif
endf

function help.fun(fun$[40])
    pComments(fun$,1)
endf    

function help.fulllist()
dim f,k,p,s$[80]
dim sl, tpos=0
    f = fopen(manFile$, "r")
    if f <> 0 then
        k = fgets(s$,f)
        while (k = 0) && (strlen(s$) > 1)
            p = pos(s$,"#")
            pComments(mid$(s$,0,p),0)
            k = fgets(s$,f)        
        wend
        fclose(f)
    else
        print "cant open ",manFile$    
    endif
endf

// *****************************************************************************
// help file system for use with SD Card
// *****************************************************************************
function help()
    print
    print "help.list - gives a list of functions on the help file\n"
    print "help.fulllist - gives more detailed list of functions\n"
    print "help.fun(\"function name\") - lists the function and any comments\n"
endf
    