// This file contains all the start up Functions that are required late on
// there is no logging at this stage. Change any globals or system contants
// in thisfile and then type at the console flclear(0)


constant STARTUP 1 // this file id

// logging constants
constant LOGFILE$ "/wf_link.log"
// logout is a flag 0x is to console
//                  x0 is to file
constant LOGOUT  3  //
constant DOW$ "MonTueWedThuFriSatSun"
constant MONTH$ "JanFebMarAprMayJunJulAugSepOctNovDec"
// an increase in the size of the local variable ram is required, mainly for
// the webserver as large strings are used.
constant SYS_VARLOCAL  450


// *****************************************************************************
// system log for debugging etc.
// *****************************************************************************
function syslog(from$[30],s$[80])
dim dt$[128],sysFile,v
    // these three simply add the day of the week name
    dt$=mid$(date$(),0,9) // includes space
    v=(mid$(date$(),9,2)-1)*3
    if v < 21 then
        dt$=dt$+mid$(DOW$,v,3)
    else
        dt$=dt$+"   "
    endif
    dt$=dt$+" "+time$()+" "+"["+from$+"] "+s$+"\r\n"
    if (LOGOUT & 1) <> 0 then
        print dt$
    endif
    if (LOGOUT & 2) <> 0 then
        sysFile=fopen(LOGFILE$,"a") // append to existing file
        if sysFile = 0 then // file does not exist yet
            print "\nCreating ",LOGFILE$
            sysFile=fopen(LOGFILE$,"w") // create new file
        endif
        if sysFile <> 0 then // just in case
            fwrite(dt$,strlen(dt$),?v,sysFile)
            fclose(sysFile)
        else
            print "At syslog - Cant open logfile"
        endif
    endif
endf

