// Add utils to this file
//
constant NETUTILS 1   // source ID
//
constant GOOGLEIP$ "173.194.34.184" // to get time

// *****************************************************************************
// Uses excxxx command an ping to disciver the ip of a dns name for example
// print getIp$("www.byvac.com")
// Returns
//          ip address as string
//          null string
// *****************************************************************************
function getIp$(url$)
dim rv$[50]
    if Mode(1) <> 0 then
        comclear(CPORT)
        comouts(CPORT,"at+excxxx=ping -c1 "+url$+" > /dev/ttyS1\r")
        wait(1000) //get linewill timeout therwise
        getLine$('(') // disguard up to (
        rv$ = getLine$(')') // get up to closing
        comclear(CPORT) // clear rest
        if strlen(rv$) = 0 then // drops out of mode 1 on error
            mode1_check()
        endif
        return rv$
    else
        syslog("getIp","Could not set Mode 1")
    endif
endf

// *****************************************************************************
// Connects 
// mode is "client" or "server"
// *****************************************************************************
function connectIP(ip$[30],port,mode$[8],pro$[8])
dim fail=0
    syslog("connectIP",format$("Connection request for %s",ip$))
    if Mode(1) <> 0 then
        if set_remoteip$(ip$) <> "ok"  then
            fail=fail+1
        endif
        if set_remoteport(port) = 0 then
            fail=fail+1
        endif
        if set_mode$(mode$) <> "ok" then
            fail=fail+1
        endif
        if set_remotepro$(pro$) <> "ok" then
            fail=fail+1
        endif
        reconnect()
    else
        syslog("connectIP","Could not set Mode 1")
    endif
    if fail <> 0 then
        syslog("connectIP",format$("Could not connect to ip %s",ip$))
    endif
endf

// ======================== date and time ======================================

//******************************************************************************
// see if date is set on the RTC by looking at the year, crude but there is no 
// other way to do it, returns 1 if set
//******************************************************************************
function checkDate()
dim v, rv
    v = mid$(date$(),6,3)
    if v > 50 then
        rv = 0
    else
        rv = 1
    endif
    return rv
endf

// *****************************************************************************
// gets date and time from UK web page GMT!
// This is really a stop gap until a proper time server is used. The format
// could easily change
// *****************************************************************************
function setDT()
dim s$[50]="x",t$[10],p
dim a,b,c,d
    syslog("setDT","Date and time request")
    connectIP(GOOGLEIP$,80,"client","tcp")
    wait(1000)
    comouts(CPORT,"GET / HTTP/1.1\r\n\r\n") // request gest header
    wait(1000)
    if comkey?(CPORT) < 10 then
        syslog("setDT",format$("Failed to get HTTP head from %s",GOOGLEIP$))
    else
        while strlen(s$) <> 0
            s$=getLine$(LF)
            if pos(s$,"Date:") >= 0 then
                syslog("setDT",format$("setting to %s",s$))
                // set system time and date
                // convert day of week intoa number
                t$ = mid$(s$,6,3)
                d = (pos(DOW$,t$) / 3) + 1
                if d < 0 then
                    d = 1
                endif
                //  day
                c = mid$(s$,11,2)
                // Month
                t$ = mid$(s$,14,3)
                b = (pos(MONTH$,t$) / 3) + 1
                if b < 0 then
                    b = 1
                endif
                // year
                a = mid$(s$,20,2)
                setdate(a,b,c,d)
                // Time
                a = mid$(s$,23,2)
                b = mid$(s$,26,2)
                c = mid$(s$,29,2)
                settime(a,b,c)
                break
            endif
        wend
        comclear(CPORT) // clear rest of head
    endif
endf

// *****************************************************************************
// checks data and time and sets it if possibe
// *****************************************************************************
function checkDT()
    if checkDate() = 0 then
        syslog("checkDT", "attempting to set date and time")
        if connected() = 1 then
            setDT()
        endif
    endif
endf
    
// *****************************************************************************
// puts server back for web server
// *****************************************************************************
function setServer(port)
dim fail=0
    syslog("setServer","reset back to server")
    if Mode(1) <> 0 then
        if set_remoteport(port) < 0 then
            fail=fail+1
        endif
        if set_mode$("server") <> "ok" then
            fail=fail+1
        endif
        if set_remotepro$("tcp") <> "ok" then
            fail=fail+1
        endif
        reconnect()
    else
        syslog("setServer","Could not set Mode 1")
    endif
    if fail <> 0 then
        syslog("setServer","Could not set server mode")
    endif
endf
